<%@ page import="com.niku.union.security.SecurityIdentifier" %>
<%@ page import="com.niku.union.security.UserSessionController" %>
<%@ page import="com.niku.union.security.UserSessionControllerFactory" %>
<%@ page import="com.niku.union.web.DefaultWebRequest" %>
<%@ page import="com.niku.union.web.DefaultWebResponse" %>
<%@ page import="com.niku.union.web.WebRequest" %>
<%@ page import="com.niku.union.web.WebResponse" %>
<%@ page import="com.niku.union.web.WebSession" %>
<%
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  // sso.jsp
  //
  //
  // This file contain calls into Clarity code to create a user session based on a user name.
  //
  //  Clients must add their own Java code to take an encrypted HTTP value and decrypt it, 
  //  to provide a valid Clarity user name.
  //
  //  The value may be transmitted via an HTTP parameters, header, or cookie.
  //
  //  As supplied (i.e. before client modification) sso.jsp is generic, 
  //  however once modified by the client this file becomes a customization specific to the client and:
  //
  //     1. maintenance (including change/version management) of this modified file is the responsibility of the Client. 
  //     2. testing and validation of this modified file is the responsibility of the Client.
  //     3. existence of the correct version of this modified file in the <clarity_home>/webroot directory is the responsibility of the Client.
  //     4. the Client's SSO server must forward requests direct to the sso.jsp page
  //
  // Use:
  //
  //  1. Copy finished sso.jsp to the <clarity_home>/webroot directory.
  //  2. Under Application, enable Use Single Sign-On for the desired application server instance(s) in NSA.
  //  3. Under Security, fill in appropriate values for Logout URL and Authentication Error URL.  (Token Name
  //     and Token Type are not used when a custom sso.jsp is used.
  //  4. Restart the affected application services.
  //
  //  The Client's custom SSO proxy server must redirect users after login outside of Clarity
  //  to /niku/sso.jsp page, passing along the encrypted token.  The Client's own custom Java code
  //  inside the customized sso.jsp must do the work to extract a Clarity username from it.
  //  No Clarity code will do any of the decryption itself.  
  //
  //  Example using sso.jsp as-is:
  //     http://<servername>/niku/sso.jsp?username=<someuser>.
  //
  //  If the username is valid you are redirected to the home page, logged in as <someuser>. If
  //  authentication fails, you will be redirected according to the Security -> SSO settings 
  //  defined in NSA.
  //
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  boolean initialized = false;

  // =====================================
  // CUSTOM CODE to specify the user name.
  //
  String username = request.getParameter( "username" );   // (How NOT to do it)
  //
  // END CUSTOM CODE
  // =====================================


  if( username != null && username.length() > 0 )
  {
    try
    {
      WebRequest webRequest = new DefaultWebRequest( request );
      WebResponse webResponse = new DefaultWebResponse( response );
      WebSession webSession = null;

      webSession = new WebSession( webResponse, webRequest, pageContext.getServletContext() );

      UserSessionController usController = UserSessionControllerFactory.getInstance();
      SecurityIdentifier newSecId = usController.init( username, webSession.getSecurityIdentifier() );
      if( newSecId != null && newSecId.isUserLoggedIn() )
      {
        String userStatus = newSecId.getUserStatus();
        if( !SecurityIdentifier.INACTIVE_STATUS.equals( userStatus ) &&
          !SecurityIdentifier.LOCKED_STATUS.equals( userStatus ) )
        {
          webSession.setSecurityIdentifier( newSecId );
          if( !webSession.getSessionInitialized() )
          {
            //set browser session cookie
            webSession.initSessions( newSecId );
          }
          initialized = true;
        }
      }
    }
    catch( Exception e )
    {
      e.printStackTrace();
    }
  }


  if( initialized )
  {
    response.sendRedirect( "app?action=homeActionId" );
  }
  else
  {
    // =======================================
    // CUSTOM CODE to go elsewhere on error...
    //
    response.sendRedirect( "app" ); // Default is just show the login page.
    //
    // END CUSTOM CODE
    // =======================================
  }
%>